(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
var enabled = require('enabled');
var logCategoryConfigCache = {};

function getCategoryConfig(category) {
    var config = logCategoryConfigCache[category];
    if (!config) {
        config = {
            category: category,
            enabled: enabled(category)
        };
        logCategoryConfigCache[category] = config;
    }
    return config;
}

exports.reloadConfig = function(category) {
    if (category) {
        // Reload a specific config
        getCategoryConfig(category).enabled = enabled(category);
    } else {
        // Reload all configs
        for (var categoryName in logCategoryConfigCache) {
            if (logCategoryConfigCache.hasOwnProperty(categoryName)) {
                exports.reloadConfig(categoryName);
            }
        }
    }
};

exports.logger = function (category) {
    if (category === undefined) {
        throw new Error('Cannot create logger. Log "category" name must be specified.');
    }
    
    var LOGGER = {};
    var categoryConfig = getCategoryConfig(category);
    
    LOGGER.isDebugEnabled = function () {
        return categoryConfig.enabled;
    };

    LOGGER.debug = function (message) {
        if (LOGGER.isDebugEnabled()) {
            console.debug.apply(console, [category].concat(arguments));
        }
    };
    
    LOGGER.error = function (message) {
        console.error.apply(console, [category].concat(arguments));
    };    
    
    return LOGGER;
};
},{"enabled":11}],2:[function(require,module,exports){
var Version = require('./Version');

function ModuleSpec(qName) {
    var qNameTokens = qName.split(":");
    
    if (qNameTokens.length === 2) {
        var namespace = qNameTokens[0].trim();
        var nsTokens = namespace.split("/");
        var namespaceProvider = undefined;
        if (nsTokens.length === 2) {
            namespaceProvider = nsTokens[0].trim();
            namespace = nsTokens[1].trim();
            if (namespaceProvider !== 'plugin' && namespaceProvider !== 'core-assets') {
                console.error('Unsupported module namespace provider "' + namespaceProvider + '". Setting to undefined.');
                namespaceProvider = undefined;
            }
        }
        
        var npmName = parseNPMName(qNameTokens[1].trim());
        
        this.nsProvider = namespaceProvider;
        this.namespace = namespace;
        this.moduleName = npmName.name;
        this.moduleVersion = npmName.version;
    } else {
        // The module/bundle is not in a namespace and doesn't
        // need to be loaded i.e. it will load itself and export.
        var npmName = parseNPMName(qNameTokens[0].trim());

        this.moduleName = npmName.name;
        this.moduleVersion = npmName.version;
    }

    // Attach version compatibility info
    var versions = [];
    
    if (this.moduleVersion) {
        var moduleVersionTokens = this.moduleVersion.split(/[,|]+/);

        for (var i = 0; i < moduleVersionTokens.length; i++) {
            var moduleVersionToken = moduleVersionTokens[i].trim();
            var parsedVersion = new Version(moduleVersionToken);
            versions.push(parsedVersion);
        }
    }
    
    this.moduleCompatVersions = versions;
}

ModuleSpec.prototype.getLoadBundleVersion = function() {
    if (this.moduleCompatVersions.length === 0) {
        // If no versions were specified on the name, then we
        // just return undefined.
        return undefined;
    }
    // If a version is specified, we use the first "specific" version
    // e.g. "1.1.2" is specific while "1.1.x" and "any" are not.
    for (var i = 0; i < this.moduleCompatVersions.length; i++) {
        var version = this.moduleCompatVersions[i];
        if (version.isSpecific()) {
            return version;
        }
    }
    
    // If there's no specific version then we return the first
    // version in the list.
    return this.moduleCompatVersions[0];
};

ModuleSpec.prototype.getLoadBundleName = function() {
    var version = this.getLoadBundleVersion();
    if (version) {
        return this.moduleName + '@' + version.asBaseVersionString();
    } else {
        return this.moduleName;
    }
};

ModuleSpec.prototype.importAs = function() {
    if (this.moduleName.charAt(0) === '.') {
        return this.moduleName;
    }
    
    var version = this.getLoadBundleVersion();
    var importName = normalizePackageName(this.moduleName);
    var importNS = this.namespace;
    
    if (!importNS) {
        importNS = importName;
    }
    
    var importAs = importNS + ':' + importName;
    if (this.nsProvider) {
        importAs = this.nsProvider + '/' + importAs;
    }
    if (version) {
        importAs += '@' + version.asBaseVersionString();
    }
    
    return importAs;
};

ModuleSpec.prototype.getLoadBundleFileNamePrefix = function() {
    var version = this.getLoadBundleVersion();
    var normalizedName = normalizePackageName(this.moduleName);
    if (version) {
        // If a version was specified then we only do the script load if a
        // specific version was provided i.e. loading does not get triggered
        // by imports that specify non-specific version numbers e.g. "any"
        // or "1.2.x". A specific version number would be e.g. "1.2.3" i.e.
        // fully qualified. When loading is not triggered, the import is depending
        // on another import (with a specific version) or on a bundle do an
        // export of an internal dependency i.e. on another bundle "providing"
        // the module be exporting it.
        if (version.isSpecific()) {
            return normalizedName + '-' + version.asLoadVersionString();
        } else {
            return undefined;
        }
    } else {
        return normalizedName;
    }
};

/**
 * Normalize an NPM package name by removing all non alpha numerics and replacing
 * with hyphens.
 * @param packageName The NPM package name.
 * @returns The normalized NPM package name.
 */
function normalizePackageName(packageName) {
    packageName = packageName.replace(/[^\w.]/g, "-"); // replace non alphanumerics.
    if (packageName.charAt(0) === '-') {
        packageName = packageName.substring(1);
    }
    return packageName;
};

function parseNPMName(resourceName) {
    if (resourceName.length > 1) {
        var npmName = {};
        var orgSlashIndex = resourceName.indexOf('/');
        
        if (resourceName.charAt(0) === '@' && orgSlashIndex > 0) {
            // It's an NPM org package. Strip off the org and package
            // and add it to the name. We'll get the rest then and parse
            // that.
            npmName.name = resourceName.substring(0, orgSlashIndex + 1);
            
            // Remove the org part from the name and continue parsing.
            resourceName = resourceName.substring(orgSlashIndex + 1);
        } else {
            // Initialise it so we can append to it below.
            npmName.name = '';
        }
        
        var versionIndex = resourceName.indexOf('@');
        if (versionIndex > 0) {
            npmName.name += resourceName.substring(0, versionIndex);
            npmName.version = resourceName.substring(versionIndex + 1);
        } else {
            npmName.name += resourceName;
        }
        
        return npmName;
    } else {
        return {
            name: resourceName
        }
    }
}

module.exports = ModuleSpec;
},{"./Version":3}],3:[function(require,module,exports){
function Version(version) {
    this.raw = version;
    
    // The version string must start with a digit.
    // It's not an error for it not to start with a number e.g. it can
    // be "any" and we may introduce other aliases.
    if (!version || version.length === 0 || isNaN(version.charAt(0))) {
        return;
    }
    
    function normalizeToken(string) {
        // remove anything that's not a digit, a dot or an x.
        var normalized = string.replace(/[^\d]/g, '');
        if (normalized === '') {
            return undefined;
        }
        return normalized;
    }
    
    var versionTokens = version.split('.');
    
    this.prerelease = undefined;
    
    var patchAndPrerelease = '';
    for (var i = 2; i < versionTokens.length; i++) {
        if (patchAndPrerelease.length > 0) {
            patchAndPrerelease += '.';
        }
        patchAndPrerelease += versionTokens[i];
        
        var separatorIdx = patchAndPrerelease.indexOf('-');
        if (separatorIdx !== -1) {
            this.patch = normalizeToken(patchAndPrerelease.substring(0, separatorIdx));
            this.prerelease = patchAndPrerelease.substring(separatorIdx + 1);
        } else {
            this.patch = normalizeToken(patchAndPrerelease);
        }
    }
    
    if (versionTokens.length >= 2) {
        this.minor = normalizeToken(versionTokens[1]);
    }
    if (versionTokens.length >= 1) {
        this.major = normalizeToken(versionTokens[0]);
    }    
}

Version.prototype.isSpecific = function() {
    return (this.major !== undefined && this.minor !== undefined && this.patch !== undefined);
};

/**
 * Get the "base" version string for this version number.
 * <p/>
 * This string should only ever include the major, minor and patch tokens
 * of the version i.e. should never include a prerelease tag.
 * @returns {string}
 */
Version.prototype.asBaseVersionString = function(separator) {
    separator = (separator ? separator : '.');
    
    if (!this.major || this.major === 'x') {
        if (this.raw === 'any') {
            return this.raw;
        } else {
            return undefined;
        }
    } else if (!this.minor || this.minor === 'x') {
        return this.major + separator + 'x';
    } else if (!this.patch || this.patch === 'x') {
        return this.major + separator + this.minor + separator + 'x';
    } else {
        return this.major + separator + this.minor + separator + this.patch;
    }
};

/**
 * Get the load version string for this version number.
 * <p/>
 * This string should only ever include the major, minor and patch tokens
 * of the version i.e. should never include a prerelease tag. This function
 * just calls <code>asBaseVersionString</code>, supplying a hyphen as the
 * separator.
 * @returns {string}
 */
Version.prototype.asLoadVersionString = function() {
    return this.asBaseVersionString('-');
};

module.exports = Version;
},{}],4:[function(require,module,exports){
var internal = require("./internal");
var promise = require("./promise");
var ModuleSpec = require('./ModuleSpec');
var onRegisterTimeout;
var whoami;

/**
 * What's the top level module/bundle name.
 * @param moduleQName The module QName.
 * @returns The module QName, or undefined if unknown.
 */
exports.whoami = function(moduleQName) {
    if (moduleQName) {
        whoami = moduleQName;
        internal.whoami(whoami);
    }
    return whoami;
};

/**
 * Asynchronously import/require a set of modules.
 *
 * <p>
 * Responsible for triggering the async loading of modules if a given module is not already loaded.
 *
 * @param moduleQNames... A list of module "qualified" names, each containing the module name prefixed with the namespace
 * and separated by a colon i.e. "<namespace>:<moduleName>" e.g. "jquery:jquery2".
 *
 * @return A Promise, allowing async load of all modules. The promise is only fulfilled when all modules are loaded.
 */
exports.importModule = function() {
    if (arguments.length === 1) {
        return internal.importModule(arguments[0], onRegisterTimeout);        
    }
    
    var moduleQNames = [];    
    for (var i = 0; i < arguments.length; i++) {
        var argument = arguments[i];
        if (typeof argument === 'string') {
            moduleQNames.push(argument);
        }
    }
    
    if (moduleQNames.length == 0) {
        throw new Error("No module names specified.");
    }
    
    return promise.make(function (resolve, reject) {
        var fulfillments = [];
        
        function onFulfillment() {
            if (fulfillments.length === moduleQNames.length) {
                var modules = [];
                for (var i = 0; i < fulfillments.length; i++) {
                    if (fulfillments[i].value) {
                        modules.push(fulfillments[i].value);
                    } else {
                        // don't have everything yet so can't fulfill all.
                        return;
                    }
                }
                // If we make it here, then we have fulfilled all individual promises, which 
                // means we can now fulfill the top level import promise.
                resolve(modules);
            }
        }        
        
        // doRequire for each module
        for (var i = 0; i < moduleQNames.length; i++) {           
            function doRequire(moduleQName) {
                var promise = internal.importModule(moduleQName, onRegisterTimeout);
                var fulfillment = {
                    promise: promise,
                    value: undefined
                };
                fulfillments.push(fulfillment);
                promise
                    .onFulfilled(function(value) {
                        fulfillment.value = value;
                        onFulfillment();
                    })
                    .onRejected(function(error) {
                        reject(error);
                    });
            }
            doRequire(moduleQNames[i]);
        }
    }).applyArgsOnFulfill();    
};

/**
 * Synchronously "require" a module that it already loaded/registered.
 *
 * <p>
 * This function will throw an error if the module is not already loaded via an outer call to 'import'
 * (or 'import').
 *
 * @param moduleQName The module "qualified" name containing the module name prefixed with the namespace
 * separated by a colon i.e. "<namespace>:<moduleName>" e.g. "jquery:jquery2".
 *
 * @return The module.
 */
exports.requireModule = function(moduleQName) {
    var parsedModuleName = new ModuleSpec(moduleQName);
    var module = internal.getModule(parsedModuleName);    
    if (!module) {
        throw new Error("Unable to perform synchronous 'require' for module '" + moduleQName + "'. This module is not pre-loaded. " +
            "The module needs to have been asynchronously pre-loaded via an outer call to 'import'.");
    }
    return module.exports;
};

/**
 * Export a module.
 * 
 * @param namespace The namespace in which the module resides, or "undefined" if the modules is in
 * the "global" module namespace e.g. a Jenkins core bundle.
 * @param moduleName The name of the module. 
 * @param module The CommonJS style module, or "undefined" if we just want to notify other modules waiting on
 * the loading of this module.
 * @param onError On error callback;
 */
exports.exportModule = function(namespace, moduleName, module, onError) {
    try {
        var moduleQName = (namespace ? namespace + ':' : '') + moduleName;
        var moduleSpec = new ModuleSpec(moduleQName);
        var moduleNamespaceObj = internal.getModuleNamespaceObj(moduleSpec);
        var moduleLoadName = moduleSpec.getLoadBundleName();

        if (moduleNamespaceObj[moduleLoadName]) {
            if (namespace) {
                console.debug("Jenkins plugin module '" + namespace + ":" + moduleName + "' already registered.");
            } else {
                console.debug("Jenkins global module '" + moduleName + "' already registered.");
            }
            return;
        }

        if (!module) {
            module = {
                exports: {}
            };
        } else if (module.exports === undefined) {
            module = {
                exports: module
            };
        }
        moduleNamespaceObj[moduleLoadName] = module;

        // Notify all that the module has been registered. See internal.loadModule also.
        internal.notifyModuleExported(moduleSpec, module.exports);
    } catch (e) {
        console.error(e);
        if (onError) {
            onError(e);
        }
    }
};

/**
 * Add a module's CSS to the browser page.
 * 
 * <p>
 * The assumption is that the CSS can be accessed at e.g.
 * {@code <rootURL>/plugin/<namespace>/jsmodules/<moduleName>/style.css} i.e.
 * the pluginId acts as the namespace.
 * 
 * @param namespace The namespace in which the module resides.
 * @param moduleName The name of the module. 
 * @param onError On error callback;
 */
exports.addModuleCSSToPage = function(namespace, moduleName, onError) {
    try {
        internal.addModuleCSSToPage(namespace, moduleName);
    } catch (e) {
        console.error(e);
        if (onError) {
            onError(e);
        }
    }
};

/**
 * Add a plugin CSS file to the browser page.
 * 
 * @param pluginName The Jenkins plugin in which the module resides.
 * @param cssPath The CSS path. 
 * @param onError On error callback;
 */
exports.addPluginCSSToPage = function(pluginName, cssPath, onError) {
    try {
        internal.addPluginCSSToPage(pluginName, cssPath);
    } catch (e) {
        console.error(e);
        if (onError) {
            onError(e);
        }
    }
};

/**
 * Create a js-modules CSS id that can be used to refer to a link element.
 * @param cssPath The CSS path/url.
 * @param namespace Optional namespace.
 */
exports.toCSSId = function (cssPath, namespace) {
    return internal.toCSSId(cssPath, namespace);
};

/**
 * Add CSS file to the browser page.
 * 
 * @param cssPath The CSS path. 
 * @param onError On error callback;
 */
exports.addCSSToPage = function(cssPath, onError) {
    try {
        if (cssPath.indexOf(internal.getAdjunctURL()) === 0) {
            internal.addCSSToPage(undefined, cssPath);
        } else {
            internal.addCSSToPage(undefined, internal.getRootURL() + '/' + cssPath);
        }
    } catch (e) {
        console.error(e);
        if (onError) {
            onError(e);
        }
    }
};

/**
 * Add a javascript &lt;script&gt; element to the document &lt;head&gt;.
 * <p/>
 * Options:
 * <ul>
 *     <li><strong>scriptId</strong>: The script Id to use for the element. If not specified, one will be generated from the scriptSrc.</li>
 *     <li><strong>async</strong>: Asynchronous loading of the script. Default is 'true'.</li>
 *     <li><strong>success</strong>: An optional onload success function for the script element.</li>
 *     <li><strong>error</strong>: An optional onload error function for the script element. This is called if the .js file exists but there's an error evaluating the script. It is NOT called if the .js file doesn't exist (ala 404).</li>
 *     <li><strong>removeElementOnLoad</strong>: Remove the script element after loading the script. Default is 'false'.</li>
 * </ul>
 * 
 * @param scriptSrc The script src.
 * @param options Optional script load options object. See above.
 */
exports.addScript = function(scriptSrc, options) {
    internal.addScript(scriptSrc, options);
};

/**
 * Set the module registration timeout i.e. the length of time to wait for a module to load before failing.
 *
 * @param timeout Millisecond duration before onRegister times out. Defaults to 10000 (10s) if not specified.
 */
exports.setRegisterTimeout = function(timeout) {
    onRegisterTimeout = timeout;
}

/**
 * Set the Jenkins root/base URL.
 * 
 * @param rootUrl The root/base URL.
 */
exports.setRootURL = function(rootUrl) {
    internal.setRootURL(rootUrl);
};

exports.getRootURL = internal.getRootURL;
exports.getAdjunctURL = internal.getAdjunctURL;

/**
 * Manually initialise the Jenkins Global.
 * <p>
 * This should only ever be called from a test environment.
 */
exports.initJenkinsGlobal = function() {
    internal.initJenkinsGlobal();
};

internal.onJenkinsGlobalInit(function(jenkinsCIGlobal) {
    // For backward compatibility, we need to make some js-modules
    // functions globally available e.g. to allow legacy code wait for
    // certain modules to be loaded, as with legacy adjuncts.
    if (!jenkinsCIGlobal._internal) {
        // Put the functions on an object called '_internal' as a way
        // of hinting to people to not use it.
        jenkinsCIGlobal._internal = {
            importModule: exports.importModule,
            addScript: internal.addScript
        };
    }
});
},{"./ModuleSpec":2,"./internal":5,"./promise":6}],5:[function(require,module,exports){
var promise = require("./promise");
var ModuleSpec = require('./ModuleSpec');

var jenkinsCIGlobal;
var globalInitListeners = [];
var whoami;

exports.whoami = function(moduleQName) {
    if (moduleQName) {
        whoami = new ModuleSpec(moduleQName);
        whoami.nsProvider = getBundleNSProviderFromScriptElement(whoami.namespace, whoami.moduleName);
    }
    return whoami;
};

exports.onJenkinsGlobalInit = function(callback) {
    globalInitListeners.push(callback);
};

exports.initJenkinsGlobal = function() {
    jenkinsCIGlobal = {
    };
    if (globalInitListeners) {
        for (var i = 0; i < globalInitListeners.length; i++) {
            globalInitListeners[i](jenkinsCIGlobal);
        }
    }
};

exports.clearJenkinsGlobal = function() {    
    jenkinsCIGlobal = undefined;
    whoami = undefined;
};

exports.getJenkins = function() {
    if (jenkinsCIGlobal) {
        return jenkinsCIGlobal;
    }
    if (window.jenkinsCIGlobal) {
        jenkinsCIGlobal = window.jenkinsCIGlobal;
    } else {
        exports.initJenkinsGlobal();
        jenkinsCIGlobal.rootURL = getRootURL();
        window.jenkinsCIGlobal = jenkinsCIGlobal;
    }   
    return jenkinsCIGlobal;
};

exports.getModuleNamespaceObj = function(moduleSpec) {
    if (moduleSpec.namespace) {
        return exports.getNamespace(moduleSpec.namespace);
    } else {
        return exports.getGlobalModules();
    }
};

exports.getNamespace = function(namespaceName) {
    var namespaces = exports.getNamespaces();
    var namespace = namespaces[namespaceName];
    if (!namespace) {
        namespace = {
            globalNS: false            
        };
        namespaces[namespaceName] = namespace;
    }
    return namespace;
};

exports.importModule = function(moduleQName, onRegisterTimeout) {
    return promise.make(function (resolve, reject) {
        var moduleSpec = new ModuleSpec(moduleQName);
        var module = exports.getModule(moduleSpec);

        if (module) {
            // module already loaded
            resolve(module.exports);
        } else {
            if (onRegisterTimeout === 0) {
                if (moduleSpec.namespace) {
                    throw new Error('Module ' + moduleSpec.namespace + ':' + moduleSpec.moduleName + ' require failure. Async load mode disabled.');
                } else {
                    throw new Error('Global module ' + moduleSpec.moduleName + ' require failure. Async load mode disabled.');
                }
            }

            // module not loaded. Load async, fulfilling promise once registered
            exports.loadModule(moduleSpec, onRegisterTimeout)
                .onFulfilled(function (moduleExports) {
                    resolve(moduleExports);
                })
                .onRejected(function (error) {
                    reject(error);
                });
        }
    });    
};

exports.loadModule = function(moduleSpec, onRegisterTimeout) {
    var module = exports.getModule(moduleSpec);
    
    if (module) {
        // Module already loaded. This prob shouldn't happen.
        console.log("Unexpected call to 'loadModule' for a module (" + moduleSpec.moduleName + ") that's already loaded.");
        return promise.make(function (resolve) {
            resolve(module.exports);
        });
    }

    function waitForRegistration(loadingModule, onRegisterTimeout) {
        return promise.make(function (resolve, reject) {
            if (typeof onRegisterTimeout !== "number") {
                onRegisterTimeout = 10000;
            }
            
            var timeoutObj = setTimeout(function () {
                // Timed out waiting on the module to load and register itself.
                if (!loadingModule.loaded) {
                    var moduleSpec = loadingModule.moduleSpec;
                    var errorDetail;
                    
                    if (moduleSpec.namespace) {
                        errorDetail = "Timed out waiting on module '" + moduleSpec.namespace + ":" + moduleSpec.moduleName + "' to load.";
                    } else {
                        errorDetail = "Timed out waiting on module '" + moduleSpec.moduleName + "' to load.";
                    }                    
                    console.error('Module load failure: ' + errorDetail);

                    // Call the reject function and tell it we timed out
                    reject({
                        reason: 'timeout',
                        detail: errorDetail
                    });
                }
            }, onRegisterTimeout);
            
            loadingModule.waitList.push({
                resolve: resolve,
                timeoutObj: timeoutObj
            });                    
        });
    }
    
    var moduleNamespaceObj = exports.getModuleNamespaceObj(moduleSpec);
    var loadModuleName = moduleSpec.getLoadBundleName();
    var loadVersion = moduleSpec.getLoadBundleVersion();
    var doScriptLoad = true;
    
    if (loadVersion) {
        // If a version was specified then we only do the script load if a
        // specific version was provided i.e. loading does not get triggered
        // by imports that specify non-specific version numbers e.g. "any"
        // or "1.2.x". A specific version number would be e.g. "1.2.3" i.e.
        // fully qualified. When loading is not triggered, the import is depending
        // on another import (with a specific version) or on another bundle to do an
        // export of an internal dependency i.e. on another bundle "providing"
        // the module by exporting it.
        doScriptLoad = loadVersion.isSpecific();
    }
    
    var loadingModule = getLoadingModule(moduleNamespaceObj, loadModuleName);
    if (!loadingModule.waitList) {
        loadingModule.waitList = [];
    }
    loadingModule.moduleSpec = moduleSpec; 
    loadingModule.loaded = false;

    try {
        return waitForRegistration(loadingModule, onRegisterTimeout);
    } finally {
        if (doScriptLoad) {
            var scriptId = exports.toModuleId(moduleSpec.namespace, loadModuleName) + ':js';
            var scriptSrc = exports.toModuleSrc(moduleSpec, 'js');
            var scriptEl = exports.addScript(scriptSrc, {
                scriptId: scriptId,
                scriptSrcBase: ''
            });

            if (scriptEl) {
                // Set the module spec info on the <script> element. This allows us to resolve the
                // nsProvider for that bundle after 'whoami' is called for it (as it loads). whoami
                // is not called with the nsProvider info on it because a given bundle can
                // potentially be loaded from multiple different ns providers, so we only resole the provider
                // at load-time i.e. just after a bundle is loaded it calls 'whoami' for itself
                // and then this module magically works out where it was loaded from (it's nsProvider)
                // by locating the <script> element and using this information. For a module/bundle, knowing
                // where it was loaded from is important because it dictates where that module/bundle
                // should load it dependencies from. For example, the Bootstrap module/bundle depends on the
                // jQuery bundle. So, if the bootstrap bundle is loaded from the 'core-assets' namespace provider,
                // then that means the jQuery bundle should also be loaded from the 'core-assets'
                // namespace provider.
                // See getBundleNSProviderFromScriptElement.
                scriptEl.setAttribute('data-jenkins-module-nsProvider', moduleSpec.nsProvider);
                scriptEl.setAttribute('data-jenkins-module-namespace', moduleSpec.namespace);
                scriptEl.setAttribute('data-jenkins-module-moduleName', loadModuleName);
            }
        }
    }
};

exports.addScript = function(scriptSrc, options) {
    if (!scriptSrc) {
        console.warn('Call to addScript with undefined "scriptSrc" arg.');
        return undefined;
    }    
    
    var normalizedOptions;
    
    // If there's no options object, create it.
    if (typeof options === 'object') {
        normalizedOptions = options;
    } else {
        normalizedOptions = {};
    }
    
    // May want to transform/map some urls.
    if (normalizedOptions.scriptSrcMap) {
        if (typeof normalizedOptions.scriptSrcMap === 'function') {
            scriptSrc = normalizedOptions.scriptSrcMap(scriptSrc);
        } else if (Array.isArray(normalizedOptions.scriptSrcMap)) {
            // it's an array of suffix mappings
            for (var i = 0; i < normalizedOptions.scriptSrcMap.length; i++) {
                var mapping = normalizedOptions.scriptSrcMap[i];
                if (mapping.from && mapping.to) {
                    if (endsWith(scriptSrc, mapping.from)) {
                        normalizedOptions.originalScriptSrc = scriptSrc;
                        scriptSrc = scriptSrc.replace(mapping.from, mapping.to);
                        break;
                    }
                }
            }
        }
    }
    
    normalizedOptions.scriptId = getScriptId(scriptSrc, options);
    
    // set some default options
    if (normalizedOptions.async === undefined) {
        normalizedOptions.async = true;
    }
    if (normalizedOptions.scriptSrcBase === undefined) {
        normalizedOptions.scriptSrcBase = '@root';
    }
    
    if (normalizedOptions.scriptSrcBase === '@root') {
        normalizedOptions.scriptSrcBase = getRootURL() + '/';
    } else if (normalizedOptions.scriptSrcBase === '@adjunct') {
        normalizedOptions.scriptSrcBase = getAdjunctURL() + '/';
    }

    var document = window.document;
    var head = exports.getHeadElement();
    var script = document.getElementById(normalizedOptions.scriptId);

    if (script) {
        var replaceable = script.getAttribute('data-replaceable');
        if (replaceable && replaceable === 'true') {
            // This <script> element is replaceable. In this case, 
            // we remove the existing script element and add a new one of the
            // same id and with the specified src attribute.
            // Adding happens below.
            script.parentNode.removeChild(script);
        } else {
            return undefined;
        }
    }

    script = createElement('script');

    // Parts of the following onload code were inspired by how the ACE editor does it,
    // as well as from the follow SO post: http://stackoverflow.com/a/4845802/1166986
    var onload = function (_, isAborted) {
        script.setAttribute('data-onload-complete', true);
        try {
            if (isAborted) {
                console.warn('Script load aborted: ' + scriptSrc);
            } else if (!script.readyState || script.readyState === "loaded" || script.readyState === "complete") {
                // If the options contains an onload function, call it.
                if (typeof normalizedOptions.success === 'function') {
                    normalizedOptions.success(script);
                }
                return;
            }
            if (typeof normalizedOptions.error === 'function') {
                normalizedOptions.error(script, isAborted);
            }
        } finally {
            if (normalizedOptions.removeElementOnLoad) {
                head.removeChild(script);
            }
            // Handle memory leak in IE
            script = script.onload = script.onreadystatechange = null;
        }
    };
    script.onload = onload; 
    script.onreadystatechange = onload;

    script.setAttribute('id', normalizedOptions.scriptId);
    script.setAttribute('type', 'text/javascript');
    script.setAttribute('src', normalizedOptions.scriptSrcBase + scriptSrc);
    if (normalizedOptions.originalScriptSrc) {
        script.setAttribute('data-referrer', normalizedOptions.originalScriptSrc);        
    }
    if (normalizedOptions.async) {
        script.setAttribute('async', normalizedOptions.async);
    }
    
    head.appendChild(script);
    
    return script;
};

exports.notifyModuleExported = function(moduleSpec, moduleExports) {
    var moduleNamespaceObj = exports.getModuleNamespaceObj(moduleSpec);
    var loadingModule = getLoadingModule(moduleNamespaceObj, moduleSpec.getLoadBundleName());
    
    loadingModule.loaded = true;
    if (loadingModule.waitList) {
        for (var i = 0; i < loadingModule.waitList.length; i++) {
            var waiter = loadingModule.waitList[i];
            clearTimeout(waiter.timeoutObj);
            waiter.resolve(moduleExports);
        }
    }    
};

exports.addModuleCSSToPage = function(namespace, moduleName) {
    var moduleSpec = exports.getModuleSpec(namespace + ':' + moduleName);
    var cssElId = exports.toModuleId(namespace, moduleName) + ':css';
    var cssPath = exports.toModuleSrc(moduleSpec, 'css');
    return exports.addCSSToPage(namespace, cssPath, cssElId);
};

exports.addPluginCSSToPage = function(namespace, cssPath, cssElId) {
    var cssPath = exports.getPluginPath(namespace) + '/' + cssPath;
    return exports.addCSSToPage(namespace, cssPath, cssElId);
};

exports.toCSSId = function (cssPath, namespace) {
    return 'jenkins-js-module:' + (namespace || 'global' ) + ':css:' + cssPath;
};

exports.addCSSToPage = function(namespace, cssPath, cssElId) {
    var document = window.document;
    
    if (cssElId === undefined) {
        cssElId = exports.toCSSId(cssPath, namespace);
    }
    
    var cssEl = document.getElementById(cssElId);
    
    if (cssEl) {
        // already added to page
        return;
    }

    var docHead = exports.getHeadElement();
    cssEl = createElement('link');
    cssEl.setAttribute('id', cssElId);
    cssEl.setAttribute('type', 'text/css');
    cssEl.setAttribute('rel', 'stylesheet');
    cssEl.setAttribute('href', cssPath);
    docHead.appendChild(cssEl);

    return cssEl;
};

exports.getGlobalModules = function() {
    var jenkinsCIGlobal = exports.getJenkins();
    if (!jenkinsCIGlobal.globals) {
        jenkinsCIGlobal.globals = {
            globalNS: true
        };
    }
    return jenkinsCIGlobal.globals;
};

exports.getNamespaces = function() {
    var jenkinsCIGlobal = exports.getJenkins();

    // The namespaces are stored in an object named "plugins". This is a legacy from the
    // time when all modules lived in plugins. By right we'd like to rename this, but
    // that would cause compatibility issues.

    if (!jenkinsCIGlobal.plugins) {
        jenkinsCIGlobal.plugins = {
            __README__: 'This object holds namespaced JS modules/bundles, with the property names representing the module namespace. It\'s name ("plugins") is a legacy thing. Changing it to a better name (e.g. "namespaces") would cause compatibility issues.'
        };
    }
    return jenkinsCIGlobal.plugins;
};

exports.toModuleId = function(namespace, moduleName) {
    return 'jenkins-js-module:' + (namespace ? namespace + ':' : '') + moduleName;
};

exports.toModuleSrc = function(moduleSpec, srcType) {
    var nsProvider = moduleSpec.nsProvider;

    // If a moduleSpec on a module/bundle import doesn't specify a namespace provider
    // (i.e. is of the form "a:b" and not "core-assets/a:b"),
    // then check "this" bundles module spec and see if it was imported from a specific
    // namespace. If it was (e.g. 'core-assets'), then import from that namespace.
    if (nsProvider === undefined) {
        nsProvider = thisBundleNamespaceProvider();
        if (nsProvider === undefined) {
            nsProvider = 'adjuncts';
        }
        // Store the nsProvider back onto the moduleSpec.
        moduleSpec.nsProvider = nsProvider;
    }

    var srcPath = undefined;
    if (srcType === 'js') {
        srcPath = moduleSpec.getLoadBundleFileNamePrefix() + '.js';
    } else if (srcType === 'css') {
        srcPath = moduleSpec.getLoadBundleFileNamePrefix() + '/style.css';
    } else {
        throw new Error('Unsupported srcType "'+ srcType + '".');
    }

    if (nsProvider === 'adjuncts') {
        return exports.getAdjunctJSModulesPath(moduleSpec.namespace) + '/' + srcPath;
    } else if (nsProvider === 'plugin') {
        return exports.getPluginJSModulesPath(moduleSpec.namespace) + '/' + srcPath;
    } else if (nsProvider === 'core-assets') {
        return exports.getCoreAssetsJSModulesPath(moduleSpec.namespace) + '/' + srcPath;
    } else {
        throw new Error('Unsupported namespace provider: ' + nsProvider);
    }
};

exports.getAdjunctJSModulesPath = function(namespace) {
    if (namespace) {
        return getAdjunctURL() + '/org/jenkins/ui/jsmodules/' + namespace;
    } else {
        return getAdjunctURL() + '/org/jenkins/ui/jsmodules';
    }
};

exports.getPluginJSModulesPath = function(pluginId) {
    return exports.getPluginPath(pluginId) + '/jsmodules';
};

exports.getCoreAssetsJSModulesPath = function(namespace) {
    return getRootURL() + '/assets/' + namespace + '/jsmodules';
};

exports.getPluginPath = function(pluginId) {
    return getRootURL() + '/plugin/' + pluginId;
};

exports.getHeadElement = function() {
    var docHead = window.document.getElementsByTagName("head");
    if (!docHead || docHead.length == 0) {
        throw new Error('No head element found in document.');
    }
    return docHead[0];
};

exports.setRootURL = function(url) {    
    if (!jenkinsCIGlobal) {
        exports.initJenkinsGlobal();
    }
    jenkinsCIGlobal.rootURL = url;
};

exports.getModule = function(moduleSpec) {
    var namespace = exports.getModuleNamespaceObj(moduleSpec);
    
    if (!moduleSpec.moduleVersion) {
        return namespace[moduleSpec.moduleName];
    } else {
        for (var i = 0; i < moduleSpec.moduleCompatVersions.length; i++) {
            var moduleCompatVersion = moduleSpec.moduleCompatVersions[i];
            var module = namespace[moduleSpec.moduleName + '@' + moduleCompatVersion.raw];
            if (module) {
                return module;
            }
        }
    }
    
    return undefined;
};

exports.getModuleSpec = function(moduleQName) {
    var moduleSpec = new ModuleSpec(moduleQName);
    var moduleNamespaceObj = exports.getModuleNamespaceObj(moduleSpec);
    if (moduleNamespaceObj) {
        var loading = getLoadingModule(moduleNamespaceObj, moduleSpec.getLoadBundleName());
        if (loading && loading.moduleSpec) {
            return loading.moduleSpec;
        }
    }
    return moduleSpec;
};

function getScriptId(scriptSrc, config) {
    if (typeof config === 'string') {
        return config;
    } else if (typeof config === 'object' && config.scriptId) {
        return config.scriptId;
    } else {
        return 'jenkins-script:' + scriptSrc;
    }    
}

exports.getRootURL = getRootURL;
function getRootURL() {
    if (jenkinsCIGlobal && jenkinsCIGlobal.rootURL) {
        return jenkinsCIGlobal.rootURL;
    }
    
    var docHead = exports.getHeadElement();
    var rootURL = getAttribute(docHead, "data-rooturl");

    if (rootURL === undefined || rootURL === null) {
        // Backward compatibility - used to use a 'resurl' attribute.
        rootURL = getAttribute(docHead, "resurl");
        if (rootURL === undefined || rootURL === null) {
            throw new Error("Attribute 'data-rooturl' not defined on the document <head> element.");
        }
    }

    if (jenkinsCIGlobal) {
        jenkinsCIGlobal.rootURL = rootURL;
    }
    
    return rootURL;
}

exports.getAdjunctURL = getAdjunctURL;
function getAdjunctURL() {
    if (jenkinsCIGlobal && jenkinsCIGlobal.adjunctURL) {
        return jenkinsCIGlobal.adjunctURL;
    }
    
    var docHead = exports.getHeadElement();
    var adjunctURL = getAttribute(docHead, "data-adjuncturl");

    if (adjunctURL === undefined || adjunctURL === null) {
        // Backward compatibility - older Jenkins do not have the adjunct url on the
        // <head> element. Lets try getting the resurl (older jenkins) and patching it 
        // to be an adjunct url.
        adjunctURL = getAttribute(docHead, "resurl");
        if (adjunctURL === undefined || adjunctURL === null) {
            throw new Error("Attribute 'data-adjuncturl' not defined on the document <head> element.");
        }
        // Replace the first occurrence of 'static/' with 'adjuncts/' 
        adjunctURL = adjunctURL.replace('static\/', 'adjuncts\/');
    }

    if (jenkinsCIGlobal) {
        jenkinsCIGlobal.adjunctURL = adjunctURL;
    }
    
    return adjunctURL;
}

function createElement(name) {
    var document = window.document;
    return document.createElement(name);
}

function getAttribute(element, attributeName) {
    var value = element.getAttribute(attributeName.toLowerCase());
    
    if (value) {
        return value;
    } else {
        // try without lowercasing
        return element.getAttribute(attributeName);
    }    
}

function getLoadingModule(moduleNamespaceObj, moduleName) {
    if (!moduleNamespaceObj.loadingModules) {
        moduleNamespaceObj.loadingModules = {};
    }
    if (!moduleNamespaceObj.loadingModules[moduleName]) {
        moduleNamespaceObj.loadingModules[moduleName] = {};
    }
    return moduleNamespaceObj.loadingModules[moduleName];
}

function endsWith(string, suffix) {
    return (string.indexOf(suffix, string.length - suffix.length) !== -1);
}

function thisBundleNamespaceProvider() {
    if (whoami !== undefined) {
        return whoami.nsProvider;
    }
    return undefined;
}

function getBundleNSProviderFromScriptElement(namespace, moduleName) {
    var docHead = exports.getHeadElement();
    var scripts = docHead.getElementsByTagName("script");

    for (var i = 0; i < scripts.length; i++) {
        var script = scripts[i];
        var elNamespace = script.getAttribute('data-jenkins-module-namespace');
        var elModuleName = script.getAttribute('data-jenkins-module-moduleName');

        if (elNamespace === namespace && elModuleName === moduleName) {
            return script.getAttribute('data-jenkins-module-nsProvider');
        }
    }

    return undefined;
}
},{"./ModuleSpec":2,"./promise":6}],6:[function(require,module,exports){
exports.make = function(executor) {
    var thePromise = new APromise();
    executor.call(thePromise, function(result) {
        thePromise.resolve(result);
    }, function(reason) {
        thePromise.reject(reason);
    });
    return thePromise;
};

function APromise() {
    this.state = 'PENDING';
    this.whenFulfilled = undefined;
    this.whenRejected = undefined;
    this.applyFulfillArgs = false;
}

APromise.prototype.applyArgsOnFulfill = function() {
    this.applyFulfillArgs = true;
    return this;
}

APromise.prototype.resolve = function (result) {
    this.state = 'FULFILLED';
    
    var thePromise = this;
    function doFulfill(whenFulfilled, result) {
        if (thePromise.applyFulfillArgs) {
            whenFulfilled.apply(whenFulfilled, result);
        } else {
            whenFulfilled(result);
        }
    }
    
    if (this.whenFulfilled) {
        doFulfill(this.whenFulfilled, result);
    }
    // redefine "onFulfilled" to call immediately
    this.onFulfilled = function (whenFulfilled) {
        if (whenFulfilled) {
            doFulfill(whenFulfilled, result);
        }
        return this;
    }
};

APromise.prototype.reject = function (reason) {
    this.state = 'REJECTED';
    if (this.whenRejected) {
        this.whenRejected(reason);
    }
    // redefine "onRejected" to call immediately
    this.onRejected = function(whenRejected) {
        if (whenRejected) {
            whenRejected(reason);
        }
        return this;
    }
};

APromise.prototype.onFulfilled = function(whenFulfilled) {
    if (!whenFulfilled) {
        throw new Error('Must provide an "whenFulfilled" callback.');
    }
    this.whenFulfilled = whenFulfilled;
    return this;
};

APromise.prototype.onRejected = function(whenRejected) {        
    if (whenRejected) {
        this.whenRejected = whenRejected;
    }
    return this;
};
},{}],7:[function(require,module,exports){
var json = require('./json');

exports.get = function (url, onSuccess) {
    var http = new XMLHttpRequest();

    http.onreadystatechange = function () {
        if (http.readyState === 4) {
            if (http.status >= 200 && http.status < 300) {
                try {
                    var responseJSON = JSON.parse(http.responseText);
                    // The request may have succeeded, but there might have been
                    // some processing error on the backend and a hudson.util.HttpResponses
                    // JSON response.
                    if (responseJSON.status && responseJSON.status === 'error') {
                        console.error('SSE Gateway error response to '
                            + url + ': '
                            + responseJSON.message);
                    }

                    if (onSuccess) {
                        onSuccess(responseJSON);
                    }
                } catch (e) {
                    // Not a JSON response.
                }
            } else {
                console.error('SSE Gateway error to ' + url + ': ');
                console.error(http);
            }
        }
    };

    http.open('GET', url, true);

    http.setRequestHeader('Accept', 'application/json');
    http.send();
};

exports.post = function (data, toUrl, jenkinsSessionInfo) {
    var http = new XMLHttpRequest();

    http.onreadystatechange = function () {
        if (http.readyState === 4) {
            if (http.status >= 200 && http.status < 300) {
                try {
                    var responseJSON = JSON.parse(http.responseText);
                    // The request may have succeeded, but there might have been
                    // some processing error on the backend and a hudson.util.HttpResponses
                    // JSON response.
                    if (responseJSON.status && responseJSON.status === 'error') {
                        console.error('SSE Gateway error response to '
                            + toUrl + ': '
                            + responseJSON.message);
                    }
                } catch (e) {
                    // Not a JSON response.
                }
            } else {
                console.error('SSE Gateway error to ' + toUrl + ': ');
                console.error(http);
            }
        }
    };

    http.open('POST', toUrl, true);

    http.setRequestHeader('Content-type', 'application/json');
    if (http.setDisableHeaderCheck
        && jenkinsSessionInfo.cookieName
        && jenkinsSessionInfo.sessionid) {
        // This is a test !!
        // XMLHttpRequest is coming from the xmlhttprequest npm package.
        // It allows us to turn off the W3C spec header checks, allowing us to set
        // the cookie and so maintain the session for the test (not running in a browser).
        http.setDisableHeaderCheck(true);
        http.setRequestHeader('Cookie', jenkinsSessionInfo.cookieName
            + '=' + jenkinsSessionInfo.sessionid);
    }

    if (jenkinsSessionInfo.crumb
        && jenkinsSessionInfo.crumb.name
        && jenkinsSessionInfo.crumb.value) {
        http.setRequestHeader(jenkinsSessionInfo.crumb.name, jenkinsSessionInfo.crumb.value);
    }

    if (data) {
        if (typeof data === 'object') {
            http.send(json.stringify(data));
        } else {
            http.send(data);
        }
    } else {
        http.send();
    }
};
},{"./json":9}],8:[function(require,module,exports){
var eventSourceSupported = undefined;

try {
    eventSourceSupported = (window !== undefined && window.EventSource !== undefined);
} catch (e) {
    // No window. Probably running in a test.
}

function noEventSource() {
    console.warn('Jenskins SSE Gateway Client: This browser does not support EventSource. ' +
        "Where's the polyfill?");
    // TODO: Need to add browser poly-fills for stuff like this
    // See https://github.com/remy/polyfills/blob/master/EventSource.js
}

if (eventSourceSupported) {
    var internal = require('./sse-client');

    /**
     * Connect the SSE client to the server.
     * @param clientId The SSE client ID. This is a scrint but should be unique i.e. something
     * not likely to clash with another SSE instance in the same session.
     * @param onConnect Optionsal onConnect function.
     */
    exports.connect = internal.connect;

    /**
     * Disconnect the SSE client from the server.
     */
    exports.disconnect = internal.disconnect;

    /**
     * Subscribe to a channel.
     * @param channelName The channel name.
     * @param filter An optional filter for the channel events.
     * @param callback The callback to be called on receipt of these events.
     */
    exports.subscribe = internal.subscribe;

    /**
     * Subscribe from a channel.
     * @param callback The callback used when subscribing.
     */
    exports.unsubscribe = internal.unsubscribe;
} else {
    exports.connect = function () {
        noEventSource();
    };
    exports.disconnect = function () {
        noEventSource();
    };
    exports.subscribe = function () {
        noEventSource();
    };
    exports.unsubscribe = function () {
        noEventSource();
    };
}
},{"./sse-client":10}],9:[function(require,module,exports){
exports.stringify = function (o) {
    if (Array.prototype.toJSON) { // Prototype f's this up something bad
        var protoJSON = {
            a: Array.prototype.toJSON,
            o: Object.prototype.toJSON,
            h: Hash.prototype.toJSON,
            s: String.prototype.toJSON
        };
        try {
            delete Array.prototype.toJSON;
            delete Object.prototype.toJSON;
            delete Hash.prototype.toJSON;
            delete String.prototype.toJSON;

            return JSON.stringify(o);
        } finally {
            if (protoJSON.a) {
                Array.prototype.toJSON = protoJSON.a;
            }
            if (protoJSON.o) {
                Object.prototype.toJSON = protoJSON.o;
            }
            if (protoJSON.h) {
                Hash.prototype.toJSON = protoJSON.h;
            }
            if (protoJSON.s) {
                String.prototype.toJSON = protoJSON.s;
            }
        }
    }
    else {
        return JSON.stringify(o);
    }
};
},{}],10:[function(require,module,exports){
var jsModules = require('@jenkins-cd/js-modules');
var LOGGER = require('@jenkins-cd/diag').logger('sse');
var ajax = require('./ajax');
var json = require('./json');

// General configuration settings. Can be updated
// via the exported configure function.
var configuration = {
    batchConfigDelay: 100,
    sendSessionId: false
};

var jenkinsUrl = undefined;
var eventSource = undefined;
var eventSourceListenerQueue = [];
var jenkinsSessionInfo = undefined;
var subscriptions = [];
var channelListeners = {};
var eventSourceSupported = (window !== undefined && window.EventSource !== undefined);
var configurationBatchId = 0;
var configurationQueue = {};
var configurationListeners = {};
var nextDoConfigureTimeout = undefined;

function resetConfigQueue() {
    configurationBatchId++;
    configurationQueue = {};
    configurationListeners[configurationBatchId.toString()] = [];
}
resetConfigQueue();

function addConfigQueueListener(listener) {
    // Config queue listeners are always added against the current batchId.
    // When that config batch is sent, these listeners will be notified on
    // receipt of the "configure" SSE event, which will contain that batchId.
    // See the notifyConfigQueueListeners function below.
    var batchListeners = configurationListeners[configurationBatchId.toString()];
    if (batchListeners) {
        batchListeners.push(listener);
    } else {
        LOGGER.error(new Error('Unexpected call to addConfigQueueListener for an ' +
            'obsolete/unknown batchId ' + configurationBatchId + '. This should never happen!!'));
    }
}

function notifyConfigQueueListeners(batchId) {
    var batchListeners = configurationListeners[batchId.toString()];
    if (batchListeners) {
        delete configurationListeners[batchId.toString()];
        for (var i = 0; i < batchListeners.length; i++) {
            try {
                batchListeners[i]();
            } catch (e) {
                LOGGER.error('Unexpected error calling config queue listener.', e);
            }
        }
    }
}

function clearDoConfigure() {
    if (nextDoConfigureTimeout) {
        clearTimeout(nextDoConfigureTimeout);
    }
    nextDoConfigureTimeout = undefined;
}
function scheduleDoConfigure(delay) {
    clearDoConfigure();
    var timeoutDelay = delay;
    if (timeoutDelay === undefined) {
        timeoutDelay = configuration.batchConfigDelay;
    }
    nextDoConfigureTimeout = setTimeout(doConfigure, timeoutDelay);
}
function normalizeUrl(url) {
    if (!url) {
        return '';
    }
    // remove trailing slashes
    var newUrl = url;
    while (newUrl.charAt(newUrl.length - 1) === '/') {
        newUrl = newUrl.substring(0, newUrl.length - 1);
    }
    return newUrl;
}

exports.configure = function (config) {
    if (config) {
        for (var prop in config) {
            if (config.hasOwnProperty(prop)) {
                configuration[prop] = config[prop];
            }
        }
    }
};

exports.connect = function (clientId, onConnect) {
    if (eventSource) {
        return;
    }

    jenkinsUrl = undefined;
    if (arguments.length === 1 && typeof arguments[0] === 'object') {
        var configObj = arguments[0];
        /* eslint-disable */
        clientId = configObj.clientId;
        onConnect = configObj.onConnect;
        jenkinsUrl = configObj.jenkinsUrl;
        /* eslint-enable */
    }

    // If the browser supports HTML5 sessionStorage, then lets append a tab specific
    // random ID to the client ID. This allows us to cleanly connect to a backend session,
    // but to do it on a per tab basis i.e. reloading from the same tab reconnects that tab
    // to the same backend dispatcher but allows each tab to have their own dispatcher,
    // avoiding wierdness when multiple tabs are open to the same "clientId".
    if (window.sessionStorage) {
        var storeKey = 'jenkins-sse-gateway-client-' + clientId;
        var tabClientId = window.sessionStorage.getItem(storeKey);

        /* eslint-disable */
        if (tabClientId) {
            clientId = tabClientId;
        } else {
            clientId += '-' + generateTabId();
            window.sessionStorage.setItem(storeKey, clientId);
        }
        /* eslint-enable */
    }

    if (!jenkinsUrl) {
        jenkinsUrl = jsModules.getRootURL();
    }
    jenkinsUrl = normalizeUrl(jenkinsUrl);
    exports.jenkinsUrl = jenkinsUrl;

    if (typeof clientId !== 'string') {
        LOGGER.error("SSE clientId not specified in 'connect' request.");
        return;
    }

    if (!eventSourceSupported) {
        console.warn("This browser does not support EventSource. Where's the polyfill?");
        // TODO: Need to add browser poly-fills for stuff like this
        // See https://github.com/remy/polyfills/blob/master/EventSource.js
    } else {
        var connectUrl = jenkinsUrl + '/sse-gateway/connect?clientId='
                                    + encodeURIComponent(clientId);
        ajax.get(connectUrl, function (response) {
            var listenUrl = jenkinsUrl + '/sse-gateway/listen/' + encodeURIComponent(clientId);

            if (configuration.sendSessionId) {
                // Sending the jsessionid helps headless clients to maintain
                // the session with the backend.
                var jsessionid = response.data.jsessionid;
                listenUrl += ';jsessionid=' + jsessionid;
            }

            var EventSource = window.EventSource;
            var source = new EventSource(listenUrl);

            source.addEventListener('open', function (e) {
                LOGGER.debug('SSE channel "open" event.', e);
                if (e.data) {
                    jenkinsSessionInfo = JSON.parse(e.data);
                    if (onConnect) {
                        onConnect(jenkinsSessionInfo);
                    }
                }
            }, false);
            source.addEventListener('configure', function (e) {
                LOGGER.debug('SSE channel "configure" ACK event (see batchId on event).', e);
                if (e.data) {
                    var configureInfo = JSON.parse(e.data);
                    notifyConfigQueueListeners(configureInfo.batchId);
                }
            }, false);
            source.addEventListener('reload', function (e) {
                LOGGER.debug('SSE channel "reload" event received. Reloading page now.', e);
                window.location.reload(true);
            }, false);

            // Add any listeners that have been requested to be added.
            for (var i = 0; i < eventSourceListenerQueue.length; i++) {
                var config = eventSourceListenerQueue[i];
                source.addEventListener(config.channelName, config.listener, false);
            }

            eventSource = source;
        });
    }
};

exports.disconnect = function () {
    if (eventSource) {
        try {
            if (typeof eventSource.removeEventListener === 'function') {
                for (var channelName in channelListeners) {
                    if (channelListeners.hasOwnProperty(channelName)) {
                        try {
                            eventSource.removeEventListener(channelName,
                                channelListeners[channelName]);
                        } catch (e) {
                            LOGGER.error('Unexpected error removing listners', e);
                        }
                    }
                }
            }
        } finally {
            try {
                eventSource.close();
            } finally {
                eventSource = undefined;
                channelListeners = {};
            }
        }
    }
};

exports.subscribe = function () {
    clearDoConfigure();

    var channelName;
    var filter;
    var callback;
    var onSubscribed;

    // sort out the args.
    if (arguments.length === 1 && typeof arguments[0] === 'object') {
        var configObj = arguments[0];
        channelName = configObj.channelName;
        callback = configObj.onEvent;
        filter = configObj.filter;
        onSubscribed = configObj.onSubscribed;
    } else {
        for (var i = 0; i < arguments.length; i++) {
            var arg = arguments[i];
            if (typeof arg === 'string') {
                channelName = arg;
            } else if (typeof arg === 'function') {
                callback = arg;
            } else if (typeof arg === 'object') {
                filter = arg;
            }
        }
    }

    if (channelName === undefined) {
        throw new Error('No channelName arg provided.');
    }
    if (callback === undefined) {
        throw new Error('No callback arg provided.');
    }

    var config;

    if (filter) {
        // Clone the filter as the config.
        config = JSON.parse(json.stringify(filter));
    } else {
        config = {};
    }

    config.jenkins_channel = channelName;

    subscriptions.push({
        config: config,
        callback: callback
    });
    if (!configurationQueue.subscribe) {
        configurationQueue.subscribe = [];
    }
    configurationQueue.subscribe.push(config);

    if (!channelListeners[channelName]) {
        addChannelListener(channelName);
    }

    scheduleDoConfigure();

    if (onSubscribed) {
        addConfigQueueListener(onSubscribed);
    }

    return callback;
};

exports.unsubscribe = function (callback, onUnsubscribed) {
    clearDoConfigure();

    // callback is the only mandatory param
    if (callback === undefined) {
        throw new Error('No callback provided');
    }

    var newSubscriptionList = [];
    for (var i = 0; i < subscriptions.length; i++) {
        var subscription = subscriptions[i];
        if (subscription.callback === callback) {
            if (!configurationQueue.unsubscribe) {
                configurationQueue.unsubscribe = [];
            }
            configurationQueue.unsubscribe.push(subscription.config);
        } else {
            newSubscriptionList.push(subscription);
        }
    }
    subscriptions = newSubscriptionList;

    scheduleDoConfigure();

    if (onUnsubscribed) {
        addConfigQueueListener(onUnsubscribed);
    }
};

function addChannelListener(channelName) {
    var listener = function (event) {
        if (LOGGER.isDebugEnabled()) {
            var channelEvent = JSON.parse(event.data);
            LOGGER.debug('Received event "' + channelEvent.jenkins_channel
                + '/' + channelEvent.jenkins_event + ':', channelEvent);
        }

        // Iterate through all of the subscriptions, looking for
        // subscriptions on the channel that match the filter/config.
        var processCount = 0;
        for (var i = 0; i < subscriptions.length; i++) {
            var subscription = subscriptions[i];

            if (subscription.config.jenkins_channel === channelName) {
                // Parse the data every time, in case the
                // callback modifies it.
                var parsedData = JSON.parse(event.data);
                // Make sure the data matches the config, which is the filter
                // plus the channel name (and the message should have the
                // channel name in it).
                if (containsAll(parsedData, subscription.config)) {
                    try {
                        processCount++;
                        subscription.callback(parsedData);
                    } catch (e) {
                        console.trace(e);
                    }
                }
            }
        }
        if (processCount === 0) {
            LOGGER.debug('Event not processed by any active listeners ('
                + subscriptions.length + ' of). Check event payload against subscription ' +
                'filters - see earlier "notification configuration" request(s).');
        }
    };
    channelListeners[channelName] = listener;
    if (eventSource) {
        eventSource.addEventListener(channelName, listener, false);
    } else {
        eventSourceListenerQueue.push({
            channelName: channelName,
            listener: listener
        });
    }
}

function containsAll(object, filter) {
    for (var property in filter) {
        if (filter.hasOwnProperty(property)) {
            var objVal = object[property];
            var filterVal = filter[property];
            if (objVal === undefined) {
                return false;
            }
            // String comparison i.e. ignore type
            if (objVal.toString() !== filterVal.toString()) {
                return false;
            }
        }
    }
    return true;
}

function doConfigure() {
    nextDoConfigureTimeout = undefined;

    if (!jenkinsSessionInfo && eventSourceSupported) {
        // Can't do it yet. Need to wait for the SSE Gateway to
        // open the SSE channel + send the jenkins session info.
        scheduleDoConfigure(100);
    } else {
        var configureUrl = jenkinsUrl + '/sse-gateway/configure?batchId=' + configurationBatchId;

        LOGGER.debug('Sending notification configuration request for configuration batch '
            + configurationBatchId + '.', configurationQueue);

        configurationQueue.dispatcherId = jenkinsSessionInfo.dispatcherId;
        ajax.post(configurationQueue, configureUrl, jenkinsSessionInfo);

        resetConfigQueue();
    }
}

/**
 * Generate a random "enough" string from the current time in
 * millis + a random generated number string.
 * @returns {string}
 */
function generateTabId() {
    return (new Date().getTime()) + '-' + (Math.random() + 1).toString(36).substring(7);
}
},{"./ajax":7,"./json":9,"@jenkins-cd/diag":1,"@jenkins-cd/js-modules":4}],11:[function(require,module,exports){
'use strict';

var env = require('env-variable');

/**
 * Checks if a given namespace is allowed by the environment variables.
 *
 * @param {String} name namespace that should be included.
 * @param {Array} variables
 * @returns {Boolean}
 * @api public
 */
module.exports = function enabled(name, variables) {
  var envy = env()
    , variable
    , i = 0;

  variables = variables || ['diagnostics', 'debug'];

  for (; i < variables.length; i++) {
    if ((variable = envy[variables[i]])) break;
  }

  if (!variable) return false;

  variables = variable.split(/[\s,]+/);
  i = 0;

  for (; i < variables.length; i++) {
    variable = variables[i].replace('*', '.*?');

    if ('-' === variable.charAt(0)) {
      if ((new RegExp('^'+ variable.substr(1) +'$')).test(name)) {
        return false;
      }

      continue;
    }

    if ((new RegExp('^'+ variable +'$')).test(name)) {
      return true;
    }
  }

  return false;
};
},{"env-variable":12}],12:[function(require,module,exports){
(function (process){
'use strict';

var has = Object.prototype.hasOwnProperty;

/**
 * Gather environment variables from various locations.
 *
 * @param {Object} environment The default environment variables.
 * @returns {Object} environment.
 * @api public
 */
function env(environment) {
  environment = environment || {};

  if ('object' === typeof process && 'object' === typeof process.env) {
    env.merge(environment, process.env);
  }

  if ('undefined' !== typeof window) {
    if ('string' === window.name && window.name.length) {
      env.merge(environment, env.parse(window.name));
    }

    try { env.merge(environment, env.parse(window.localStorage.env || window.localStorage.debug)); }
    catch (e) {}

    if (
         'object' === typeof window.location
      && 'string' === typeof window.location.hash
      && window.location.hash.length
    ) {
      env.merge(environment, env.parse(window.location.hash.charAt(0) === '#'
        ? window.location.hash.slice(1)
        : window.location.hash
      ));
    }
  }

  //
  // Also add lower case variants to the object for easy access.
  //
  var key, lower;
  for (key in environment) {
    lower = key.toLowerCase();

    if (!(lower in environment)) {
      environment[lower] = environment[key];
    }
  }

  return environment;
}

/**
 * A poor man's merge utility.
 *
 * @param {Object} base Object where the add object is merged in.
 * @param {Object} add Object that needs to be added to the base object.
 * @returns {Object} base
 * @api private
 */
env.merge = function merge(base, add) {
  for (var key in add) {
    if (has.call(add, key)) {
      base[key] = add[key];
    }
  }

  return base;
};

/**
 * A poor man's query string parser.
 *
 * @param {String} query The query string that needs to be parsed.
 * @returns {Object} Key value mapped query string.
 * @api private
 */
env.parse = function parse(query) {
  var parser = /([^=?&]+)=([^&]*)/g
    , result = {}
    , part;

  if (!query) return result;

  for (;
    part = parser.exec(query);
    result[decodeURIComponent(part[1])] = decodeURIComponent(part[2])
  );

  return result.env || result;
};

//
// Expose the module
//
module.exports = env;

}).call(this,require('_process'))
},{"_process":13}],13:[function(require,module,exports){
var process = module.exports = {};

// cached from whatever global is present so that test runners that stub it
// don't break things.  But we need to wrap it in a try catch in case it is
// wrapped in strict mode code which doesn't define any globals.  It's inside a
// function because try/catches deoptimize in certain engines.

var cachedSetTimeout;
var cachedClearTimeout;

function defaultSetTimout() {
    throw new Error('setTimeout has not been defined');
}
function defaultClearTimeout () {
    throw new Error('clearTimeout has not been defined');
}
(function () {
    try {
        if (typeof setTimeout === 'function') {
            cachedSetTimeout = setTimeout;
        } else {
            cachedSetTimeout = defaultSetTimout;
        }
    } catch (e) {
        cachedSetTimeout = defaultSetTimout;
    }
    try {
        if (typeof clearTimeout === 'function') {
            cachedClearTimeout = clearTimeout;
        } else {
            cachedClearTimeout = defaultClearTimeout;
        }
    } catch (e) {
        cachedClearTimeout = defaultClearTimeout;
    }
} ())
function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
        //normal enviroments in sane situations
        return setTimeout(fun, 0);
    }
    // if setTimeout wasn't available but was latter defined
    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
        cachedSetTimeout = setTimeout;
        return setTimeout(fun, 0);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedSetTimeout(fun, 0);
    } catch(e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
            return cachedSetTimeout.call(null, fun, 0);
        } catch(e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
            return cachedSetTimeout.call(this, fun, 0);
        }
    }


}
function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
        //normal enviroments in sane situations
        return clearTimeout(marker);
    }
    // if clearTimeout wasn't available but was latter defined
    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
        cachedClearTimeout = clearTimeout;
        return clearTimeout(marker);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedClearTimeout(marker);
    } catch (e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
            return cachedClearTimeout.call(null, marker);
        } catch (e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
            // Some versions of I.E. have different rules for clearTimeout vs setTimeout
            return cachedClearTimeout.call(this, marker);
        }
    }



}
var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;

function cleanUpNextTick() {
    if (!draining || !currentQueue) {
        return;
    }
    draining = false;
    if (currentQueue.length) {
        queue = currentQueue.concat(queue);
    } else {
        queueIndex = -1;
    }
    if (queue.length) {
        drainQueue();
    }
}

function drainQueue() {
    if (draining) {
        return;
    }
    var timeout = runTimeout(cleanUpNextTick);
    draining = true;

    var len = queue.length;
    while(len) {
        currentQueue = queue;
        queue = [];
        while (++queueIndex < len) {
            if (currentQueue) {
                currentQueue[queueIndex].run();
            }
        }
        queueIndex = -1;
        len = queue.length;
    }
    currentQueue = null;
    draining = false;
    runClearTimeout(timeout);
}

process.nextTick = function (fun) {
    var args = new Array(arguments.length - 1);
    if (arguments.length > 1) {
        for (var i = 1; i < arguments.length; i++) {
            args[i - 1] = arguments[i];
        }
    }
    queue.push(new Item(fun, args));
    if (queue.length === 1 && !draining) {
        runTimeout(drainQueue);
    }
};

// v8 likes predictible objects
function Item(fun, array) {
    this.fun = fun;
    this.array = array;
}
Item.prototype.run = function () {
    this.fun.apply(null, this.array);
};
process.title = 'browser';
process.browser = true;
process.env = {};
process.argv = [];
process.version = ''; // empty string to avoid regexp issues
process.versions = {};

function noop() {}

process.on = noop;
process.addListener = noop;
process.once = noop;
process.off = noop;
process.removeListener = noop;
process.removeAllListeners = noop;
process.emit = noop;

process.binding = function (name) {
    throw new Error('process.binding is not supported');
};

process.cwd = function () { return '/' };
process.chdir = function (dir) {
    throw new Error('process.chdir is not supported');
};
process.umask = function() { return 0; };
},{}],14:[function(require,module,exports){
var ___$$$___requiredModuleMappings = [];

var ___$$$___jsModules = require('@jenkins-cd/js-modules');

___$$$___jsModules.whoami('jenkins-cd-sse-gateway-0-0-9');

/*** Start Module Exec Function ***************************************/
function ___$$$___exec() {
    'use strict';

//
// NOTE: This file is generated and should NOT be added to source control.
//

var jsModules = require('@jenkins-cd/js-modules');

jsModules.exportModule('jenkins-cd-sse-gateway', 'jenkins-cd-sse-gateway@0.0.9', require('@jenkins-cd/sse-gateway'));
jsModules.exportModule('jenkins-cd-sse-gateway', 'jenkins-cd-sse-gateway@0.0.x', require('@jenkins-cd/sse-gateway'));
jsModules.exportModule('jenkins-cd-sse-gateway', 'jenkins-cd-sse-gateway@0.x', require('@jenkins-cd/sse-gateway'));
jsModules.exportModule('jenkins-cd-sse-gateway', 'jenkins-cd-sse-gateway@any', require('@jenkins-cd/sse-gateway'));

}
/*** End Module Exec Function   ***************************************/

function ___$$$___doExports() {
    // Do exports, if any ....
    

}

function ___$$$___doCSS() {
}

function ___$$$___doBundleInit() {
    try {
        ___$$$___exec();
        ___$$$___doExports();
        ___$$$___doCSS();
    } catch (e) {
        console.error('Error initializing Jenkins JavaScript bundle "jenkins-cd-sse-gateway-0-0-9"', e);
    }
}

if (___$$$___requiredModuleMappings.length > 0) {
    ___$$$___jsModules.importModule.apply(___$$$___jsModules.importModule, ___$$$___requiredModuleMappings)
        .onFulfilled(function() {
        ___$$$___doBundleInit();
    });
} else {
    ___$$$___doBundleInit();
}
},{"@jenkins-cd/js-modules":4,"@jenkins-cd/sse-gateway":8}]},{},[14]);
